﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;

namespace SpreadTest3
{
    public class CreateFileLogicWithThreadLv1 : ActionThreadWithCache<string>
    {
        #region 实现单例模式
        protected static ActionThreadWithCache<string> _ActionThreadWithCacheE = null;
        /// <summary>
        /// 对象锁
        /// </summary>
        protected static readonly object syncRoot = new object();
        /// <summary>
        /// 私有构造函数
        /// </summary>
        private CreateFileLogicWithThreadLv1()
        {
        }

        /// <summary>
        /// 得到唯一对象
        /// </summary>
        /// <returns></returns>
        public static ActionThreadWithCache<string> GetInstance()
        {
            //Double-Check Locking（双重锁定）
            if (_ActionThreadWithCacheE == null)
            {
                lock (syncRoot)
                {
                    if (_ActionThreadWithCacheE == null)
                    {
                        _ActionThreadWithCacheE = new CreateFileLogicWithThreadLv1();
                        _ActionThreadWithCacheE.SetValue(10, "生成文件线程");
                    }
                }
            }
            return _ActionThreadWithCacheE;
        }
        #endregion 实现单例模式
        private const string EXTENDNAME = "pdf";

        public override void BatchActionDetail(List<string> lstCActionEs)
        {
            try
            {
                TestFileLogic iTestFileLogicE = new TestFileLogic();
                foreach(string strFileName in lstCActionEs)
                {
					iTestFileLogicE.ExportToPdf(strFileName);
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }
            finally
            {
                GC.Collect();
            }
        }
    }
}
