﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Drawing.Printing;

namespace SpreadTest3
{
    public class TestFileLogic
    {
        #region 私有变量

        /// <summary>
        /// 报表控件
        /// </summary>
        private FarPoint.Win.Spread.FpSpread fpSpread1 = null;
        #endregion 私有变量

        /// <summary>
        /// 构造函数
        /// </summary>
        /// <param name="fpSpread"></param>
        public TestFileLogic()
        {
            this.fpSpread1 = new FarPoint.Win.Spread.FpSpread();
        }

        ~TestFileLogic()
        {
            //this.Invoke(new EventHandler(delegate
            //    {
            //        this.fpSpread1 = null;
            //        GC.Collect();
            //    }));
        }

        public void Release()
        {
            //System.Windows.Forms.Control.Invoke(new EventHandler(delegate
            //{
            //}));
            this.fpSpread1 = null;
            GC.Collect();
        }

        /// <summary>
        /// 构造函数
        /// </summary>
        /// <param name="fpSpread"></param>
        public TestFileLogic(FarPoint.Win.Spread.FpSpread fpSpread)
        {
            if (fpSpread == null)
            {
                fpSpread = new FarPoint.Win.Spread.FpSpread();
            }
            this.fpSpread1 = fpSpread;
        }

        public void LoadFileByPath(out string strMessage)
        {				
            string strStartPath = System.Windows.Forms.Application.StartupPath;
			string strPath = System.IO.Path.Combine(strStartPath, "Area.xml");
            strMessage = string.Empty;
			if (!System.IO.File.Exists(strPath))
            {
				strMessage = string.Format("文件【{0}】不存在！", strPath);
                return;
            }
			fpSpread1.Open(strPath);
            fpSpread1.Refresh();
        }

        public void ExportToPdf()
        {
            System.Windows.Forms.SaveFileDialog saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
            saveFileDialog1.FileName = string.Empty;
            saveFileDialog1.Filter = "PDF文件(*.pdf)|*.pdf";
            if(saveFileDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                ExportToPdf(saveFileDialog1.FileName);
            }
        }

        /// <summary>
        /// 导出pdf
        /// </summary>
        public void ExportToPdf(string strFileName)
        {
			string strMessage = string.Empty;
			LoadFileByPath(out strMessage);
			if (!string.IsNullOrEmpty(strMessage))
			{
				System.Windows.Forms.MessageBox.Show(strMessage);
				return;
			}
            FarPoint.Win.Spread.PrintInfo pi = new FarPoint.Win.Spread.PrintInfo();
            pi.PrintToPdf = true;
            pi.PdfWriteMode = FarPoint.Win.Spread.PdfWriteMode.New;
            pi.PdfWriteTo = FarPoint.Win.Spread.PdfWriteTo.File;
            pi.Orientation = FarPoint.Win.Spread.PrintOrientation.Landscape;

            pi.PdfFileName = strFileName;
            fpSpread1.ActiveSheet.PrintInfo = pi;
            fpSpread1.PrintSheet(0);
            //foreach (string strFileName in lstFileNames)
            //{
            //}
        }
    }
}
